

procedure DoDischargeValve;
begin
 MOMONOFF(openDischargeValveCommand,dischargeValveOpenTimer,
          dischargeValveOpened,openDischargeValveTT,openDischargeValveFail,
          closeDischargeValveCommand,dischargeValveCloseTimer,
          dischargeValveClosed,closeDischargeValveTT,closeDischargeValveFail,
          discchargeValveState);
end;

procedure DoTankValve;
begin
 MOMONOFF(openTankValveCommand,tankValveOpenTimer,
          tankValveOpened,openTankValveTT,openTankValveFail,
          closeTankValveCommand,tankValveCloseTimer,
          tankValveClosed,closeTankValveTT,closeTankValveFail,
          tankValveState);
end;

//The below code is not called.
//It is an example of what the simulator Momentry On Off function,
//minus failed logic.
//This is also a general example.

procedure DoDischargeValve_Example;
const
 opnCmdIndex      = 0;
 opnedIndex       = 1;
 opnTimingIndex   = 2;

 clsCmdIndex      = 0;
 clsedIndex       = 1;
 clsTimingIndex   = 2;
begin
//value open logic
 values:=RVS([openDischargeValveCommand,dischargeValveOpened,openDischargeValveTT]);
 if (values[opnCmdIndex] and not values[opnedIndex]) or values[opnTimingIndex] then
  value:=TMRS(dischargeValveOpenTimer,'EN',true)
 else if not TMRG(dischargeValveOpenTimer,'TT') then
  value:=TMRS(dischargeValveOpenTimer,'EN',false);

 WV(openDischargeValveTT,TMRG(dischargeValveOpenTimer,'TT')); //for valve travel

 if TMRG(dischargeValveOpenTimer,'TT') then   //not closed so shows travel
  WV(dischargeValveClosed,false);
 if TMRG(dischargeValveOpenTimer,'DN') then //add failed command logic here
  WV(dischargeValveOpened,true);

 WV(openDischargeValveCommand,false);     //reset the command

//valve close logic
 values:=RVS([closeDischargeValveCommand,dischargeValveClosed,closeDischargeValveTT]);
 if (values[clsCmdIndex] and not values[clsedIndex]) or values[clsTimingIndex] then
  value:=TMRS(dischargeValveCloseTimer,'EN',true)
 else if not TMRG(dischargeValveCloseTimer,'TT') then
  value:=TMRS(dischargeValveCloseTimer,'EN',false);

 WV(cLoseDischargeValveTT,TMRG(dischargeValveCloseTimer,'TT')); //for valve travel

 if TMRG(dischargeValveCloseTimer,'TT') then    //not open so shows travel
  WV(dischargeValveOpened,false);
 if TMRG(dischargeValveCloseTimer,'DN') then   //add failed command logic here
  WV(dischargeValveClosed,true);

 WV(closeDischargeValveCommand,false);     //reset the command

//discharge valve state
 if RV(dischargeValveOpened) then
  WV(discchargeValveState,2)        //opened
 else if RV(dischargeValveClosed) then
  WV(discchargeValveState,0)        //closed
 else
  WV(discchargeValveState,1);       //travel
end;
